# This file is a template, and might need editing before it works on your project.
# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages
#
# You can copy and paste this template into a new `.gitlab-ci.yml` file.
# You should not add this template to an existing `.gitlab-ci.yml` file by using the `include:` keyword.
#
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

stages:
  - setup
  - create_file
  - callback
  - use_file_manual

setup:
    stage: setup
    script:
        - git clone https://github.com/katieworton/test-repo.git
        - mkdir test
        - cd test
        - touch my_file
        - echo setup >> my_file
    artifacts:
        untracked: false
        when: on_success
        expire_in: 30 days
        paths:
            - test
            - test-repo

create_file:
    stage: create_file
    script:
        - cd test
        - touch my_file2
        - echo create >> my_file
    artifacts:
        untracked: false
        when: on_success
        expire_in: 30 days
        paths:
            - test
            - test-repo
    needs:
        - setup

callback:
    stage: callback
    script:
        echo callback
    needs:
        - setup
    when: on_success

use_file_manual:
    stage: use_file_manual
    image: lavasoftware/lava-test-plans:master
    script:
        - apt -q --yes update
        - apt -q --yes install git
        - pip install --upgrade pip
        - git config --global user.email "katie.worton@linaro.org"
        - git config --global user.name "Katie Worton (test automation)"
        - pip install PyGithub GitPython
        - cd test-repo
        - python test.py
    needs:
        - setup
        - callback
        - create_file
